<?php
/**
*   Main config file.
*   @version    161017:1
*   @author     karminski <code.karminski@outlook.com>
*
*/

/**
 * set default ini
 */
ini_set("date.timezone", "Asia/Harbin");


/**
 * GLOBAL const
 */
if (!defined('ENV_PRODUCT')) define("ENV_PRODUCT",  "prod");
if (!defined('ENV_BETA'))    define("ENV_BETA",     "beta");
if (!defined('ENV_TEST'))    define("ENV_TEST",     "test");
if (!defined('SERVER_ENV'))  define("SERVER_ENV",   empty($_SERVER['SERVER_ENV']) ? "" : $_SERVER['SERVER_ENV']);



/**
 * product config here
 */
$product =  array(
    'global' => array(
        'global_id'   => 'salt_fish_raw_php',
        'folder'      => '/data/repo/salt_fish_raw_php/',
    ),
    'log' => array(
        'open'        => true,
        'address'     => '/data/repo/salt_fish_raw_php/logs/', // the '/' at end of line is necessary
        'split'       => 'day', // options: month, day, hour, minute
    ),
    'storage'        => array(
        'sample' => array(
            'host'    => '192.168.0.1',
            'port'    => 3306,
            'name'    => 'sample',
            'charset' => 'utf8',
            'user'    => 'sample',
            'pass'    => 'sample',
        ),
    ),
    'cache'          => array(
        'sample_cache' => array(
            'host'     => '192.168.0.1',
            'port'     => 6379,
            'pass'     => null,
            'database' => 2,
            'timeout'  => 0,
        ),
    ),
    'mongodb' => array(
        'sample' => "mongodb://sample:password@192.168.0.1:27017/sample",
    ),
);


/**
 * beta config here
 */
$beta =  array(
    'global' => array(
        'global_id'   => 'salt_fish_raw_php',
        'folder'      => '/data/repo/salt_fish_raw_php/',
    ),
    'log' => array(
        'open'        => true,
        'address'     => '/data/repo/salt_fish_raw_php/logs/', // the '/' at end of line is necessary
        'split'       => 'day', // options: month, day, hour, minute
    ),
    'storage'        => array(
        'sample' => array(
            'host'    => '192.168.0.1',
            'port'    => 3306,
            'name'    => 'sample',
            'charset' => 'utf8',
            'user'    => 'sample',
            'pass'    => 'sample',
        ),
    ),
    'cache'          => array(
        'sample_cache' => array(
            'host'     => '127.0.0.1',
            'port'     => 6379,
            'pass'     => null,
            'database' => 0,
            'timeout'  => 0,
        ),
        
    ),
    'mongodb' => array(
        'sample' => "mongodb://sample:password@192.168.0.1:27017/sample",
    ),
);


/**
 * test config here
 */
$test =  array(
    'global' => array(
        'global_id'   => 'salt_fish_raw_php',
        'folder'      => '/data/repo/salt_fish_raw_php/',
    ),
    'log' => array(
        'open'        => true,
        'address'     => '/data/repo/salt_fish_raw_php/logs/', // the '/' at end of line is necessary
        'split'       => 'day', // options: month, day, hour, minute
    ),
    'storage'        => array(
        'sample' => array(
            'host'    => '192.168.0.1',
            'port'    => 3306,
            'name'    => 'sample',
            'charset' => 'utf8',
            'user'    => 'sample',
            'pass'    => 'sample',
        ),
    ),
    'cache'          => array(
        'sample_cache' => array(
            'host'     => '192.168.0.1',
            'port'     => 6379,
            'pass'     => null,
            'database' => 0,
            'timeout'  => 0,
        ),
        
    ),
    'mongodb' => array(
        'sample' => "mongodb://sample:password@192.168.0.1:27017/sample",
    ),
);



/**
 * change return to switch environment 
 */
if(empty(SERVER_ENV)){
    return $test;
}elseif(SERVER_ENV === ENV_BETA){
    return $beta;
}elseif(SERVER_ENV === ENV_PRODUCT){
    return $product;
}else{
    return $test;
}
