<?php
/**
* RdKafkaConsumerProxy.php
* RdKafka Proxy for kafka connection.
* @version    160411:1
* @author     karminski <code.karminski@outlook.com>
*
* @changelogs
*             160411:1 INIT version.
* 
*/

namespace SaltFish;


/**
*   CLASS RdKafkaConsumerProxy
*/
class RdKafkaConsumerProxy{

    const ERROR_NO_DATA  = 'no_data';
    const ERROR_TIME_OUT = 'timeout';


    public $RdKafkaConsumerInstance;
    public $topic;
    public $topicInstance;

    /**
     * [__construct description]
     * @param array &$connectInfo.
     * @return  boolean connect result.
     */
    public function __construct(){
        return;
    }

    /**
     * [setInstance description]
     * @param \RdKafka\KafkaConsumer $instance [description]
     */
    public function setInstance(\RdKafka\KafkaConsumer $instance){
        $this->RdKafkaConsumerInstance = $instance;
        return true;
    }

    /**
     * [setTopic description]
     * @param array $topics [description]
     */
    public function setTopic($topics = array()){
        if(!is_array($topics)){
            throw new Exception("topics must be array, if only one, write as array('your_topic')", 1);
        }
        $this->topics = $topics;
        $this->RdKafkaConsumerInstance->subscribe($this->topics);
        return true;
    }

    /**
     * [consume description]
     * @param  [type] $data  [description]
     * @param  [type] $error [description]
     * @return [type]        [description]
     */
    public function consume(&$data, &$error){
        $message = $this->RdKafkaConsumerInstance->consume(120*1000);
        switch ($message->err) {
            case RD_KAFKA_RESP_ERR_NO_ERROR:
                $data = $message;
                return true;
                break;
            case RD_KAFKA_RESP_ERR__PARTITION_EOF:
                $error = self::ERROR_NO_DATA;
                break;
            case RD_KAFKA_RESP_ERR__TIMED_OUT:
                $error = self::ERROR_TIME_OUT;
                break;
            default:
                throw new \Exception($message->errstr(), $message->err);
                break;
        }
        return false;
    }


    /**
     * [__destruct description]
     */
    public function __destruct(){
        return $this->disconnect();
    }

    /**
     * [disconnect description]
     * @return boolean result
     */
    public function disconnect(){
        unset($this->RdKafkaConsumerInstance);
        return true;
    }


}
