<?php
/**
* RdKafkaProducerProxy.php
* RdKafka Proxy for kafka connection.
* @version    160411:1
* @author     karminski <code.karminski@outlook.com>
*
* @changelogs
*             160411:1 INIT version.
* 
*/

namespace SaltFish;


/**
*   CLASS RdKafkaProducerProxy
*/
class RdKafkaProducerProxy{

    public $RdKafkaProducerInstance;
    public $topic;
    public $topicInstance;

    /**
     * [__construct description]
     * @param array &$connectInfo.
     * @return  boolean connect result.
     */
    public function __construct(){
        return;
    }

    /**
     * [setInstance description]
     * @param \RdKafka\Producer $instance [description]
     */
    public function setInstance(\RdKafka\Producer $instance){
        $this->RdKafkaProducerInstance = $instance;
        return true;
    }

    /**
     * [setTopic description]
     * @param [type] $topic [description]
     */
    public function setTopic($topic){
        $this->topic = $topic;
        $this->topicInstance = $this->RdKafkaProducerInstance->newTopic($this->topic);
    }

    /**
     * [produce description]
     * @param  [type]  $pattition   [description]
     * @param  integer $messageFlag [description]
     * @param  [type]  &$payload    [description]
     * @return [type]               [description]
     */
    public function produce($pattition, $messageFlag = 0, $payload){
        $this->topicInstance->produce($pattition, $messageFlag, $payload);
        $this->RdKafkaProducerInstance->poll(0);
    }

    /**
     * [__destruct description]
     */
    public function __destruct(){
        return $this->disconnect();
    }

    /**
     * [disconnect description]
     * @return boolean result
     */
    public function disconnect(){
        unset($this->RdKafkaProducerInstance);
        return true;
    }


}
